<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined ( 'JPATH_BASE' ) or die ();

class JElementJsusers2 extends JElement {
	
	var $_name = 'jsusers2';
	
	function fetchElement($name, $value, &$node, $control_name) {
		
		global $mainframe;
		
		$name_values = "values";
		
		$is_juser_exist = is_dir ( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_juser' );
		if (! $is_juser_exist) {
			return '<b><a href="http://joomsuite.com/index.php?option=com_resource&view=article&Itemid=13">Jomsuite User</a> is not installed on your Joomla site</b>';
		}
		
		$db = &JFactory::getDBO ();

		$allow_fields ='';
		if( !empty($value) && $mainframe->isSite() ){
			if( !is_array($value) )
				$value = array($value);
			$allow_fields = " AND f.id IN (".implode(",",$value).") ";
			
			$selected = isset($value[0]) ? $value[0] : null ;
		}else{
			$selected = $value;
		}
		
		$invite_label = $node->attributes ( 'invite_label' );
		
		$query ="   SELECT f.id as value, CONCAT(f.title,' (',f.alias,')') as label" . 
				"\n     FROM #__juser_extended_fields AS f" . 
				"\n    WHERE f.published = 1 AND f.type IN( 'checkbox', 'select', 'radio', 'text', 'date' )" .$allow_fields.
				"\n ORDER BY f.title";
		
		//text,textarea,checkbox,radio,select,date,calendar,phone,file,separator				   

		$db->setQuery ( $query );
		$fields = $db->loadObjectList ();
		
		$options = Array ();
		foreach ( $fields as $field ) {
			$options [] = JHTML::_ ( 'select.option', $field->value, $field->label );
		}
		if (! $node->attributes ( 'hide_none' )) {
			if (! $invite_label) {
				$invite_label = 'Do not use';
			}
			array_unshift ( $options, JHTML::_ ( 'select.option', '-1', '- ' . JText::_ ( $invite_label ) . ' -' ) );
		}
		
		$out = JHTML::_ ( 'select.genericlist', $options, '' . $control_name . '[' . $name . '][]', 
		$mainframe->isSite() ? 'class="inputbox" onChange="if ( check(this.value)>=0 ) xajax_jsCallAnalyticsPlugin(\'analytics\', \'jsuser2\', \'xajax_loadFieldValues\', {value: this.getValue(), id:\''.$control_name.$name_values.'\', rep_id: getReportID()});" ' : ' class="inputbox" style="width:90%;" multiple="multiple"', 'value', 'text', $selected, $control_name.$name );
		
		if($mainframe->isSite())
		{
			if ( empty($value) )
				$value = array();
				
			$doc = &JFactory::getDocument();
			$doc->addScriptDeclaration("
			
			var available_ids = new Array(".implode(",",$value).");
			
			function getReportID() {
				return \$('adminForm').getElements('input[name=id]').getValue();
			}
			
			function check(id){
				return available_ids.indexOf(parseInt(id));
			}
			
			window.addEvent('domready', function(){
				xajax_jsCallAnalyticsPlugin('analytics', 'jsuser2', 'xajax_loadFieldValues', {value: $('".$control_name.$name."').getValue(), id:'".$control_name.$name_values."', rep_id: getReportID()});
			});
			
			");
		}
		
		return $out;
	}
}